igeo

## Class ISurfaceSlopeField

- java.lang.Object
- - igeo.IObject
  - - igeo.IAgent
    - - igeo.IField
      - - igeo.I3DField
        - - igeo.ISurfaceSlopeField

- All Implemented Interfaces:
    I3DFieldI, IDynamics, IFieldI, ISubobject

      public class ISurfaceSlopeField
      extends I3DField

  3D vector filed defined by a NURBS surface slope in respect to a given vector.
  Author:
    Satoru Sugihara

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ISurfaceSlopeField.ISurfaceSlopeFieldGeo`

  - ### Field Summary

    - ### Fields inherited from class igeo.I3DField

      `field`

    - ### Fields inherited from class igeo.IField

      `targetClasses`

    - ### Fields inherited from class igeo.IAgent

      `alive, duration, interactOverridden, localDynamics, parent, targets, time`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ISurfaceSlopeField(ISurfaceI srf)`
    `ISurfaceSlopeField(ISurfaceI srf, IVec gravityDir)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ISurfaceSlopeField` | `bidirectional(boolean b)` if bidirectional is on, field force vector is flipped when velocity of particle is going opposite
    `ISurfaceSlopeField` | `constantIntensity(boolean b)` if output vector is besed on constant length (intensity) or variable depending geometry when curve or surface tangent is used
    `ISurfaceSlopeField` | `decay(IDecay decay, double threshold)` custom decay
    `ISurfaceSlopeField` | `gauss(double threshold)` alias of gaussianDecay
    `ISurfaceSlopeField` | `gaussian(double threshold)` alias of gaussianDecay
    `ISurfaceSlopeField` | `gaussianDecay(double threshold)` set Gaussian decay with threshold; Threshold is used as double of standard deviation (when distance is eqaul to threshold, output is 13.5% of original).
    `ISurfaceSlopeField` | `intensity(double i)` set output intensity
    `ISurfaceSlopeField` | `linear(double threshold)` alias of linearDecay
    `ISurfaceSlopeField` | `linearDecay(double threshold)` set linear decay with threshold; When distance is equal to threshold, output is zero.
    `ISurfaceSlopeField` | `noDecay()` set no decay
    `ISurfaceSlopeField` | `threshold(double t)` set decay threshold

    - ### Methods inherited from class igeo.I3DField

      `applyField, del, del, field, get, get, intensity, threshold`

    - ### Methods inherited from class igeo.IField

      `clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, clr, hide, hsb, hsb, hsb, hsb, interact, isTarget, isTargetClass, layer, name, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setColor, setHSBColor, setHSBColor, setHSBColor, setHSBColor, show, target, target, targetClass, targetClass, weight, weight`

    - ### Methods inherited from class igeo.IAgent

      `addDynamics, alive, deletDynamics, deleteDynamics, deleteDynamics, duration, duration, dynamicsNum, getDynamics, initAgent, interact, localDynamics, parent, parent, postinteract, postupdate, preinteract, preupdate, removeTarget, removeTarget, setColor, setColor, setColor, setColor, target, target, targetNum, targets, time, time, update, updateGraphic, updateTarget`

    - ### Methods inherited from class igeo.IObject

      `addUserData, addUserData, alpha, alphaInt, attr, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, cp, createGraphic, defaultAttribute, deleteGraphic, dup, getAWTColor, getColor, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isValid, isVisible, layer, layer, name, red, redInt, resetGraphic, saturation, server, setColor, setColor, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ISurfaceSlopeField

          public ISurfaceSlopeField(ISurfaceI srf)

    - #### ISurfaceSlopeField

          public ISurfaceSlopeField(ISurfaceI srf,
                            IVec gravityDir)

  - ### Method Detail

    - #### noDecay

          public ISurfaceSlopeField noDecay()

      Description copied from class: `I3DField`
      set no decay
      Specified by:
        `noDecay` in interface `IFieldI`
      Overrides:
        `noDecay` in class `I3DField`

    - #### linearDecay

          public ISurfaceSlopeField linearDecay(double threshold)

      Description copied from class: `I3DField`
      set linear decay with threshold; When distance is equal to threshold, output is zero.
      Specified by:
        `linearDecay` in interface `IFieldI`
      Overrides:
        `linearDecay` in class `I3DField`

    - #### linear

          public ISurfaceSlopeField linear(double threshold)

      Description copied from class: `I3DField`
      alias of linearDecay
      Specified by:
        `linear` in interface `IFieldI`
      Overrides:
        `linear` in class `I3DField`

    - #### gaussianDecay

          public ISurfaceSlopeField gaussianDecay(double threshold)

      Description copied from class: `I3DField`
      set Gaussian decay with threshold; Threshold is used as double of standard deviation (when distance is eqaul to threshold, output is 13.5% of original).
      Specified by:
        `gaussianDecay` in interface `IFieldI`
      Overrides:
        `gaussianDecay` in class `I3DField`

    - #### gaussian

          public ISurfaceSlopeField gaussian(double threshold)

      Description copied from class: `I3DField`
      alias of gaussianDecay
      Specified by:
        `gaussian` in interface `IFieldI`
      Overrides:
        `gaussian` in class `I3DField`

    - #### gauss

          public ISurfaceSlopeField gauss(double threshold)

      Description copied from class: `I3DField`
      alias of gaussianDecay
      Specified by:
        `gauss` in interface `IFieldI`
      Overrides:
        `gauss` in class `I3DField`

    - #### decay

          public ISurfaceSlopeField decay(IDecay decay,
                                 double threshold)

      Description copied from class: `I3DField`
      custom decay
      Specified by:
        `decay` in interface `IFieldI`
      Overrides:
        `decay` in class `I3DField`

    - #### constantIntensity

          public ISurfaceSlopeField constantIntensity(boolean b)

      Description copied from class: `I3DField`
      if output vector is besed on constant length (intensity) or variable depending geometry when curve or surface tangent is used
      Specified by:
        `constantIntensity` in interface `IFieldI`
      Overrides:
        `constantIntensity` in class `I3DField`

    - #### bidirectional

          public ISurfaceSlopeField bidirectional(boolean b)

      if bidirectional is on, field force vector is flipped when velocity of particle is going opposite
      Specified by:
        `bidirectional` in interface `IFieldI`
      Overrides:
        `bidirectional` in class `I3DField`

    - #### threshold

          public ISurfaceSlopeField threshold(double t)

      Description copied from class: `I3DField`
      set decay threshold
      Specified by:
        `threshold` in interface `IFieldI`
      Overrides:
        `threshold` in class `I3DField`

    - #### intensity

          public ISurfaceSlopeField intensity(double i)

      Description copied from class: `I3DField`
      set output intensity
      Specified by:
        `intensity` in interface `IFieldI`
      Overrides:
        `intensity` in class `I3DField`